#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QString>
#include "Region.h"
#include "util.h"
#include "MedianCut.h"
#include "point.h"


namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

protected:
    void changeEvent(QEvent *e);

  private slots :
/// \brief slot to load the EXR file and display it in window
      void LoadEXR();
      void DoMediunCut();

private:
    Ui::MainWindow *m_ui;
    QString m_exrName;


};
struct ShadowPointIndex
{
  ShadowPointIndex( int i, const Point& p )
  : index( i ), point( p ) {}

  int index;
  Point point;
};

struct ShadowPointSorter
{
  bool operator() ( const ShadowPointIndex& point1, const ShadowPointIndex& point2 )
  {
    return point1.point.lum() < point2.point.lum();
  }
};
#endif // MAINWINDOW_H
