#ifndef __REGION_H__
#define __REGION_H__
#include "util.h"
#include <ImfRgbaFile.h>
#include <ImfStringAttribute.h>
#include <ImfMatrixAttribute.h>
#include <ImfArray.h>
#include "exr.h"
#include "MedianCut.h"
#include <cmath>

class MCRegion 
{
	public :
		
    int m_left;
    int m_right;
    int m_top;
    int m_bottom;
		
    MCRegion():
              m_left( 0 ),
              m_right( 0 ),
              m_top( 0 ),
              m_bottom( 0 ){;}
		
		// Region Constructor
    MCRegion(
            int _top,
            int _bottom,
            int _left,
            int _right
          ):
            m_left( _left ),
            m_right( _right ),
            m_top( _top ),
            m_bottom( _bottom ){;}

		bool isValid() const;
		int width() const;
		int height() const;
    void middle(
                int& o_x,
                int& o_y
                ) const;
    int pixelIndex(
                   const int _x,
                   const int _y
                  ) const;
		int area() const;
		int largestLength() const;
    int horizontalSum(
                      const EXR * _exr,
                      float * _sums
                     )const;
    int verticalSum(
                    const EXR * _exr,
                    float * _sums
                   )const;
    int sum(
             const EXR * _exr,
             float * _sums
           )const;

    void medianPoint(
                      const EXR * _img,
                      int& o_x,
                      int& o_y
                     )const;

    void cut(
             int _median,
             MCRegion& o_r0,
             MCRegion& o_r1
            )const;
};


#endif
