#ifndef __EXR_H__
#define __EXR_H__

#include "util.h"
#include <ImfRgbaFile.h>
#include <ImfStringAttribute.h>
#include <ImfMatrixAttribute.h>
#include <ImfArray.h>


// The EXR object
class EXR
{
public:

	// Constructor
  EXR():
        m_pixels( 0 ),
        m_lums( 0 ),
        m_width( 0 ),
        m_height( 0 ) {;}
	// Destructor
	~EXR();

	// Load an EXR
  bool load(
            const char * _fileName
           );

	// Return the dimensions
	int width() const;
	int height() const;



	// Get a coloured pixel
  Imf::Rgba pixel(
                  const int _x,
                  const int _y
                 ) const;

	// Get a luminance pixel
  float lum(
            const int _x,
            const int _y
           ) const;

private:

	// The pixel array
	Imf::Rgba *	m_pixels;
  float *m_lums;

	// The dimensions
  int m_width;
  int m_height;

};




#endif
