#ifndef __POINT_H__
#define __POINT_H__
#include <ImfRgbaFile.h>
#include <ImfStringAttribute.h>
#include <ImfMatrixAttribute.h>
#include <ImfArray.h>

// The light point class
class Point
{
  public:


  // Constructor
  Point():
          m_x( 0 ),
          m_y( 0 ),
          m_colour() {;}

  Point(
        const Point& _p
       ) :
          m_x( _p.m_x ),
          m_y( _p.m_y ),
          m_imgX( _p.m_imgX ),
          m_imgY( _p.m_imgY ),
          m_colour( _p.m_colour ) {;}

    // The normalised coordinates
    float m_x;
    float m_y;

    // The image coordinates
    int m_imgX;
    int m_imgY;

    // The colour
    Imf::Rgba m_colour;

    // Get it's luminance value
    float lum() const;

    // Get the rotation
    void angles(
                float& _theta,
                float& _phi,
                bool _mode
               ) const;
};

#endif
